import { TypedEvents, RequestOptions, XHR, XhrOptions } from '@ztimson/utils';

export type ApiEvents = TypedEvents & {
    REQUEST: (request: Promise<any>, options: RequestOptions) => any;
    RESPONSE: (response: any, options: RequestOptions) => any;
    REJECTED: (response: Error, options: RequestOptions) => any;
    TOKEN: (token: string | null) => any;
};
export declare class Api extends XHR {
    readonly url: string;
    readonly opts: XhrOptions;
    private emitter;
    private _token;
    get token(): string | null;
    set token(token: string | null);
    constructor(url?: string, opts?: XhrOptions);
    emit: <K extends string | symbol>(event: K, ...args: Parameters<ApiEvents[K]>) => void;
    off: <K extends string | symbol = string>(event: K, listener: ApiEvents[K]) => void;
    on: <K extends string | symbol = string>(event: K, listener: ApiEvents[K]) => () => void;
    once: <K extends string | symbol = string>(event: K, listener?: ApiEvents[K] | undefined) => Promise<any>;
    request<T>(options: RequestOptions): Promise<T>;
}
//# sourceMappingURL=api.d.ts.map