import { TypedEmitter, TypedEvents } from '@ztimson/utils';
import { Api } from './api';

export type MailTemplate = {
    template: string;
    data?: any;
};
export type Mail = {
    to: string | string[];
    cc?: string[];
    bcc?: string[];
    subject?: string;
    body: string | MailTemplate;
};
export type EmailEvents = TypedEvents & {
    SENT: (email: Mail) => any;
};
export declare class Email extends TypedEmitter<EmailEvents> {
    private readonly api;
    constructor(api: Api | string);
    send(email: Mail): Promise<unknown>;
}
//# sourceMappingURL=email.d.ts.map