import { Static, StaticEvents } from './static';
import { Settings, SettingEvents } from './settings';
import { Users } from './users';
import { Storage, StorageEvents } from './storage';
import { Socket } from './sockets';
import { Logger, LogLevel } from './logger';
import { TypedEmitter, TypedEvents, XhrOptions } from '@ztimson/utils';
import { Groups } from './groups';
import { Email, EmailEvents } from './email';
import { Data, DataEvents } from './data';
import { Auth, AuthEvents, AuthOptions } from './auth';
import { Api, ApiEvents } from './api';
import { Actions } from './actions';

export type MomentumEvents = TypedEvents & ApiEvents & AuthEvents & DataEvents & EmailEvents & StaticEvents & StorageEvents & SettingEvents;
export type MomentumOptions = AuthOptions & {
    logLevel?: LogLevel;
    socket?: boolean;
    api?: XhrOptions;
};
export declare class Momentum extends TypedEmitter<MomentumEvents> {
    api: Api;
    actions: Actions;
    auth: Auth;
    data: Data;
    email: Email;
    groups: Groups;
    logger: Logger;
    settings: Settings;
    socket?: Socket;
    static: Static;
    storage: Storage;
    users: Users;
    constructor(url?: string, opts?: MomentumOptions);
}
//# sourceMappingURL=momentum.d.ts.map