import { BehaviorSubject } from 'rxjs';
import { TypedEmitter, TypedEvents } from '@ztimson/utils';
import { User } from './auth';
import { Api } from './api';

export type UserEvents = TypedEvents & {
    LIST: (users: User[]) => any;
    READ: (user: User) => any;
    UPDATE: (user: User) => any;
    DELETE: (username: string) => any;
};
export declare class Users extends TypedEmitter<UserEvents> {
    private readonly api;
    private listed;
    $cache: BehaviorSubject<User[]>;
    get cache(): User[];
    set cache(val: User[]);
    constructor(api: Api | string);
    delete(username: string): Promise<void>;
    list(reload?: boolean): Promise<User[]>;
    read(username: string, reload?: boolean): Promise<User>;
    update(user: User): Promise<User>;
}
//# sourceMappingURL=users.d.ts.map